//
// This file is auto-generated by ./generate.py. Do not modify this file directly.
//

//
// Core minimizations
//
flag_type.insert({"minimize","bool"});
doMinimizeCores = args.getBoolOption("minimize", true);
flag_type.insert({"limit-minimize","int"});
minimizeLimit = args.getIntOption("limit-minimize", INT_MAX);
if ((minimizeLimit >= 2) && (minimizeLimit <= INT_MAX)) {
} else {
	terminate(1, "--limit-minimize expected x >= 2 and x <= INT_MAX\n");
}
flag_type.insert({"min-prop-limit","int"});
minimizePropLimit = args.getIntOption("min-prop-limit", 0);
if ((minimizePropLimit >= 0) && (minimizePropLimit <= INT_MAX)) {
} else {
	terminate(1, "--min-prop-limit expected x >= 0 and x <= INT_MAX\n");
}
flag_type.insert({"min-conf-limit","int"});
minimizeConfLimit = args.getIntOption("min-conf-limit", 0);
if ((minimizeConfLimit >= 0) && (minimizeConfLimit <= INT_MAX)) {
} else {
	terminate(1, "--min-conf-limit expected x >= 0 and x <= INT_MAX\n");
}
flag_type.insert({"minimize-algorithm","std::string"});
minimizeAlgorithmStr = args.getStringOption("minimize-algorithm", "destructive");
if ((minimizeAlgorithmStr == "destructive") || (minimizeAlgorithmStr == "constructive") || (minimizeAlgorithmStr == "binarysearch") || (minimizeAlgorithmStr == "cardinality") || (minimizeAlgorithmStr == "rerefute")) {
} else {
	terminate(1, "--minimize-algorithm expected one of \"destructive\",\"constructive\",\"binarysearch\",\"cardinality\",\"rerefute\"\n");
}
flag_type.insert({"separate-muser","bool"});
separate_muser = args.getBoolOption("separate-muser", true);
flag_type.insert({"rerefute","bool"});
doRerefuteCores = args.getBoolOption("rerefute", true);

//
// Non-optimal hitting sets
//
flag_type.insert({"nonopt","std::string"});
nonOptType = args.getStringOption("nonopt", "disjoint+greedy");
if ((nonOptType == "none") || (nonOptType == "disjoint") || (nonOptType == "common") || (nonOptType == "frac") || (nonOptType == "greedy") || (nonOptType == "disjoint+greedy") || (nonOptType == "common+greedy") || (nonOptType == "frac+greedy")) {
} else {
	terminate(1, "--nonopt expected one of \"none\",\"disjoint\",\"common\",\"frac\",\"greedy\",\"disjoint+greedy\",\"common+greedy\",\"frac+greedy\"\n");
}
flag_type.insert({"lp-nonopt","bool"});
lpNonOpt = args.getBoolOption("lp-nonopt", false);
flag_type.insert({"limit-nonopt","int"});
nonoptLimit = args.getIntOption("limit-nonopt", INT_MAX);
if ((nonoptLimit >= 1) && (nonoptLimit <= INT_MAX)) {
} else {
	terminate(1, "--limit-nonopt expected x >= 1 and x <= INT_MAX\n");
}
flag_type.insert({"frac-size","double"});
fracSize = args.getDoubleOption("frac-size", 0.1);
if ((fracSize > 0) && (fracSize <= 1)) {
} else {
	terminate(1, "--frac-size expected x > 0 and x <= 1\n");
}

//
// Preprocessing & Label-MaxSAT
//
flag_type.insert({"preprocess","bool"});
preprocess = args.getBoolOption("preprocess", true);
flag_type.insert({"pre-only","bool"});
pre_only = args.getBoolOption("pre-only", false);
flag_type.insert({"pre-techniques","std::string"});
pre_techniques = args.getStringOption("pre-techniques", "[bu]#[buvsrgc]");
flag_type.insert({"infile-assumptions","bool"});
inFileAssumptions = args.getBoolOption("infile-assumptions", false);

//
// Solution enumeration
//
flag_type.insert({"enumerate","bool"});
doEnumeration = args.getBoolOption("enumerate", false);
flag_type.insert({"enum-type","int"});
enumerationType = args.getIntOption("enum-type", 1);
if ((enumerationType == 1) || (enumerationType == 2) || (enumerationType == -1) || (enumerationType == -2)) {
} else {
	terminate(1, "--enum-type expected one of 1,2,-1,-2\n");
}
flag_type.insert({"enum-limit","int"});
enumerationLimit = args.getIntOption("enum-limit", INT_MAX);
if ((enumerationLimit >= 1) && (enumerationLimit <= INT_MAX)) {
} else {
	terminate(1, "--enum-limit expected x >= 1 and x <= INT_MAX\n");
}

//
// CPLEX parameters
//
flag_type.insert({"mip-threads","int"});
MIP_threads = args.getIntOption("mip-threads", 1);
if ((MIP_threads >= 0) && (MIP_threads <= INT_MAX)) {
} else {
	terminate(1, "--mip-threads expected x >= 0 and x <= INT_MAX\n");
}
flag_type.insert({"mip-intensity","int"});
MIP_intensity = args.getIntOption("mip-intensity", 2);
if ((MIP_intensity >= 0) && (MIP_intensity <= 4)) {
} else {
	terminate(1, "--mip-intensity expected x >= 0 and x <= 4\n");
}
flag_type.insert({"mip-replace","int"});
MIP_replace = args.getIntOption("mip-replace", 2);
if ((MIP_replace >= 0) && (MIP_replace <= 2)) {
} else {
	terminate(1, "--mip-replace expected x >= 0 and x <= 2\n");
}
flag_type.insert({"mip-capacity","int"});
MIP_capacity = args.getIntOption("mip-capacity", 10);
if ((MIP_capacity >= 0) && (MIP_capacity <= INT_MAX)) {
} else {
	terminate(1, "--mip-capacity expected x >= 0 and x <= INT_MAX\n");
}
flag_type.insert({"mip-poplim","int"});
MIP_poplim = args.getIntOption("mip-poplim", 100);
if ((MIP_poplim >= 0) && (MIP_poplim <= INT_MAX)) {
} else {
	terminate(1, "--mip-poplim expected x >= 0 and x <= INT_MAX\n");
}
flag_type.insert({"mip-start","int"});
MIP_start = args.getIntOption("mip-start", 2);
if ((MIP_start >= 0) && (MIP_start <= 2)) {
} else {
	terminate(1, "--mip-start expected x >= 0 and x <= 2\n");
}
flag_type.insert({"mip-emph","int"});
MIP_emph = args.getIntOption("mip-emph", 0);
if ((MIP_emph >= 0) && (MIP_emph <= 4)) {
} else {
	terminate(1, "--mip-emph expected x >= 0 and x <= 4\n");
}
flag_type.insert({"mip-export-model","std::string"});
MIP_modelFile = args.getStringOption("mip-export-model", "");
if (MIP_modelFile == "" || std::regex_match(MIP_modelFile, std::regex("\":.*\\.(?:(?:lp)|(?:sav)|(?:mps))$\""))) {
} else {
	terminate(1, "--mip-export-model expected match for \":.*\\.(?:(?:lp)|(?:sav)|(?:mps))$\"\n");
}

//
// Minisat parameters
//
flag_type.insert({"sat-polarity","int"});
SAT_userPolarity = args.getIntOption("sat-polarity", 0);
if ((SAT_userPolarity == -1) || (SAT_userPolarity == 0) || (SAT_userPolarity == 1)) {
} else {
	terminate(1, "--sat-polarity expected one of -1,0,1\n");
}
flag_type.insert({"sat-var-decay","double"});
SAT_varDecay = args.getDoubleOption("sat-var-decay", 0.95);
if ((SAT_varDecay > 0) && (SAT_varDecay < 1)) {
} else {
	terminate(1, "--sat-var-decay expected x > 0 and x < 1\n");
}
flag_type.insert({"sat-cla-decay","double"});
SAT_clauseDecay = args.getDoubleOption("sat-cla-decay", 0.999);
if ((SAT_clauseDecay > 0) && (SAT_clauseDecay < 1)) {
} else {
	terminate(1, "--sat-cla-decay expected x > 0 and x < 1\n");
}
flag_type.insert({"sat-rnd-freq","double"});
SAT_rndFreq = args.getDoubleOption("sat-rnd-freq", 0);
if ((SAT_rndFreq >= 0) && (SAT_rndFreq <= 1)) {
} else {
	terminate(1, "--sat-rnd-freq expected x >= 0 and x <= 1\n");
}
flag_type.insert({"sat-rnd-seed","double"});
SAT_rndSeed = args.getDoubleOption("sat-rnd-seed", 91648253);
if ((SAT_rndSeed >= 0) && (SAT_rndSeed < DBL_MAX)) {
} else {
	terminate(1, "--sat-rnd-seed expected x >= 0 and x < DBL_MAX\n");
}
flag_type.insert({"sat-gc-frac","double"});
SAT_gcFrac = args.getDoubleOption("sat-gc-frac", 0.2);
if ((SAT_gcFrac > 0) && (SAT_gcFrac < DBL_MAX)) {
} else {
	terminate(1, "--sat-gc-frac expected x > 0 and x < DBL_MAX\n");
}
flag_type.insert({"sat-cc-min-mode","int"});
SAT_ccMinMode = args.getIntOption("sat-cc-min-mode", 2);
if ((SAT_ccMinMode == 0) || (SAT_ccMinMode == 1) || (SAT_ccMinMode == 2)) {
} else {
	terminate(1, "--sat-cc-min-mode expected one of 0,1,2\n");
}
flag_type.insert({"sat-phase-saving","int"});
SAT_phaseSaving = args.getIntOption("sat-phase-saving", 2);
if ((SAT_phaseSaving == 0) || (SAT_phaseSaving == 1) || (SAT_phaseSaving == 2)) {
} else {
	terminate(1, "--sat-phase-saving expected one of 0,1,2\n");
}
flag_type.insert({"sat-rnd-init-act","bool"});
SAT_rndInitActivity = args.getBoolOption("sat-rnd-init-act", false);
flag_type.insert({"sat-luby","bool"});
SAT_lubyRestart = args.getBoolOption("sat-luby", true);
flag_type.insert({"sat-restart-first","int"});
SAT_restartFirst = args.getIntOption("sat-restart-first", 100);
if ((SAT_restartFirst >= 1) && (SAT_restartFirst <= INT_MAX)) {
} else {
	terminate(1, "--sat-restart-first expected x >= 1 and x <= INT_MAX\n");
}
flag_type.insert({"sat-restart-inc","double"});
SAT_restartInc = args.getDoubleOption("sat-restart-inc", 2);
if ((SAT_restartInc >= 1) && (SAT_restartInc < DBL_MAX)) {
} else {
	terminate(1, "--sat-restart-inc expected x >= 1 and x < DBL_MAX\n");
}
flag_type.insert({"sat-learntsize-factor","double"});
SAT_learntSizeFactor = args.getDoubleOption("sat-learntsize-factor", 0.33333);
if ((SAT_learntSizeFactor > 0) && (SAT_learntSizeFactor <= 100)) {
} else {
	terminate(1, "--sat-learntsize-factor expected x > 0 and x <= 100\n");
}
flag_type.insert({"sat-learntsize-inc","double"});
SAT_learntSizeInc = args.getDoubleOption("sat-learntsize-inc", 1.1);
if ((SAT_learntSizeInc > 0) && (SAT_learntSizeInc <= 100)) {
} else {
	terminate(1, "--sat-learntsize-inc expected x > 0 and x <= 100\n");
}

//
// Assumption shuffle
//
flag_type.insert({"shuffle","bool"});
do_shuffle = args.getBoolOption("shuffle", true);
flag_type.insert({"limit-shuffle","int"});
n_shuffles = args.getIntOption("limit-shuffle", 19);
if ((n_shuffles >= 1) && (n_shuffles <= INT_MAX)) {
} else {
	terminate(1, "--limit-shuffle expected x >= 1 and x <= INT_MAX\n");
}
flag_type.insert({"shuffle-disjoint","bool"});
shuffle_disjoint = args.getBoolOption("shuffle-disjoint", true);
flag_type.insert({"shuffle-core-limit","int"});
shuffle_coreLimit = args.getIntOption("shuffle-core-limit", INT_MAX);
if ((shuffle_coreLimit >= 1) && (shuffle_coreLimit <= INT_MAX)) {
} else {
	terminate(1, "--shuffle-core-limit expected x >= 1 and x <= INT_MAX\n");
}

//
// CPLEX callbacks
//
flag_type.insert({"cplex-lb-cutoff","bool"});
CPLEX_lb_cutoff = args.getBoolOption("cplex-lb-cutoff", true);
flag_type.insert({"cplex-ub-cutoff","bool"});
CPLEX_ub_cutoff = args.getBoolOption("cplex-ub-cutoff", false);
flag_type.insert({"cplex-reducedcosts","bool"});
CPLEX_reducedCosts = args.getBoolOption("cplex-reducedcosts", true);

//
// Presolve
//
flag_type.insert({"disjoint-pre","bool"});
doDisjointPhase = args.getBoolOption("disjoint-pre", true);
flag_type.insert({"equiv-seed","bool"});
doEquivSeed = args.getBoolOption("equiv-seed", true);

//
// Misc
//
flag_type.insert({"ip","bool"});
solveAsMIP = args.getBoolOption("ip", false);
flag_type.insert({"reset","bool"});
doResetClauses = args.getBoolOption("reset", true);
flag_type.insert({"invert","bool"});
doInvertActivity = args.getBoolOption("invert", true);
flag_type.insert({"random-seed","int"});
randomSeed = args.getIntOption("random-seed", 9);
if ((randomSeed >= 0) && (randomSeed <= INT_MAX)) {
} else {
	terminate(1, "--random-seed expected x >= 0 and x <= INT_MAX\n");
}
flag_type.insert({"incomplete","bool"});
incomplete = args.getBoolOption("incomplete", false);

//
// Debug and output
//
flag_type.insert({"help","bool"});
help = args.getBoolOption("help", false);
flag_type.insert({"print-cores","bool"});
printCores = args.getBoolOption("print-cores", false);
flag_type.insert({"print-stats","bool"});
printStats = args.getBoolOption("print-stats", true);
flag_type.insert({"print-hs","int"});
printHittingSets = args.getIntOption("print-hs", 0);
if ((printHittingSets == 0) || (printHittingSets == 1) || (printHittingSets == 2)) {
} else {
	terminate(1, "--print-hs expected one of 0,1,2\n");
}
flag_type.insert({"print-solutions","bool"});
printSolutions = args.getBoolOption("print-solutions", false);
flag_type.insert({"print-bounds","bool"});
printBounds = args.getBoolOption("print-bounds", true);
flag_type.insert({"stream-precision","int"});
streamPrecision = args.getIntOption("stream-precision", 15);
if ((streamPrecision >= 1) && (streamPrecision <= INT_MAX)) {
} else {
	terminate(1, "--stream-precision expected x >= 1 and x <= INT_MAX\n");
}
flag_type.insert({"verb","int"});
verbosity = args.getIntOption("verb", 1);
if ((verbosity >= 0) && (verbosity <= 3)) {
} else {
	terminate(1, "--verb expected x >= 0 and x <= 3\n");
}
flag_type.insert({"sat-verb","int"});
SAT_verbosity = args.getIntOption("sat-verb", 0);
if ((SAT_verbosity >= 0) && (SAT_verbosity <= 3)) {
} else {
	terminate(1, "--sat-verb expected x >= 0 and x <= 3\n");
}
flag_type.insert({"mip-verb","int"});
MIP_verbosity = args.getIntOption("mip-verb", 0);
if ((MIP_verbosity >= 0) && (MIP_verbosity <= 2)) {
} else {
	terminate(1, "--mip-verb expected x >= 0 and x <= 2\n");
}
